
// GetTotalPwrDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GetTotalPwr.h"
#include "GetTotalPwrDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#define ID_MY_TIMER  101

CGetTotalPwrDlg::CGetTotalPwrDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGetTotalPwrDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_SP = NULL;
}

void CGetTotalPwrDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_START_HZ, m_EDStartHz);
	DDX_Control(pDX, IDC_STOP_HZ, m_EDStopHz);
	DDX_Control(pDX, IDC_WEIGHT, m_CBWeight);

	DDX_Control(pDX, IDC_PWR_L, m_EDPwr_L);
	DDX_Control(pDX, IDC_PWR_R, m_EDPwr_R);
	DDX_Control(pDX, IDC_PWR_LR, m_EDPwr_LR);
	DDX_Control(pDX, IDC_PWR_RL, m_EDPwr_RL);
}

BEGIN_MESSAGE_MAP(CGetTotalPwrDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_OPEN, &CGetTotalPwrDlg::OnBnClickedOpen)
	ON_BN_CLICKED(IDC_RUN, &CGetTotalPwrDlg::OnBnClickedRun)
	ON_BN_CLICKED(IDC_STOP, &CGetTotalPwrDlg::OnBnClickedStop)
	ON_EN_CHANGE(IDC_START_HZ, &CGetTotalPwrDlg::OnEnChangeStartHz)
	ON_EN_CHANGE(IDC_STOP_HZ, &CGetTotalPwrDlg::OnEnChangeStopHz)
	ON_CBN_SELCHANGE(IDC_WEIGHT, &CGetTotalPwrDlg::OnSelChangeWeight)
	ON_WM_TIMER()
	ON_WM_CLOSE()
END_MESSAGE_MAP()


// CGetTotalPwrDlg message handlers

BOOL CGetTotalPwrDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CoInitialize(NULL);

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_EDStartHz.SetWindowText("500.0");
	m_EDStopHz.SetWindowText("5000.0");

	// populate the weighting combo box
	m_CBWeight.AddString("Flat");
	m_CBWeight.SetItemData(0, 0);
	m_CBWeight.AddString("A");
	m_CBWeight.SetItemData(1, 1);
	m_CBWeight.AddString("B");
	m_CBWeight.SetItemData(2, 2);
	m_CBWeight.AddString("C");
	m_CBWeight.SetItemData(3, 3);

	m_CBWeight.SetCurSel(0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGetTotalPwrDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGetTotalPwrDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



//------------------------------------------------
void CGetTotalPwrDlg::OnBnClickedOpen()
{
	if ( m_SP == NULL)
	{
		m_SP.CreateInstance( __uuidof(SpectraPLUS_SCClass) );
	}

	if ( m_SP == NULL)
	{
		MessageBox("Failure opening SpectraPLUS-SC.", AfxGetAppName(), MB_ICONSTOP);
		return;
	}


	// NOTE - Using a config file with SpectraPLUS-SC is highly recommended
	// m_SP->LoadConfig("C:\\SpectraPLUS_SC\\Config\\test2.cfg");

	//m_SP->SetMode(0);  // Realtime
	//m_SP->SetSamplingRate(48000);
    //m_SP->SetNumChannels(2);
	//m_SP->SetSamplingPrecision(24);
	//m_SP->SetDualChannelProcessingMode(2);  // both left and right channels

}

//------------------------------------------------
void CGetTotalPwrDlg::OnClose()
{
	KillTimer( ID_MY_TIMER );

	if ( m_SP == NULL)
	{
		m_SP = NULL;  // smart pointer - handles itself
	}

	CDialog::OnClose();
}

//------------------------------------------------
void CGetTotalPwrDlg::OnBnClickedRun()
{
	if ( m_SP == NULL)
	{
		MessageBox("SpectraPLUS-SC is not open", AfxGetAppName(), MB_ICONSTOP);
		return;
	}

	m_SP->Run();

	KillTimer( ID_MY_TIMER );
	SetTimer( ID_MY_TIMER, 500, NULL );  // 500 msec update rate
}

//------------------------------------------------
void CGetTotalPwrDlg::OnBnClickedStop()
{
	KillTimer( ID_MY_TIMER );

	if ( m_SP == NULL)
	{
		MessageBox("SpectraPLUS-SC is not open", AfxGetAppName(), MB_ICONSTOP);
		return;
	}

	m_SP->Stop();
}

//------------------------------------------------
void CGetTotalPwrDlg::OnEnChangeStartHz()
{
	GetResults();
}

//------------------------------------------------
void CGetTotalPwrDlg::OnEnChangeStopHz()
{
	GetResults();
}

//------------------------------------------------
void CGetTotalPwrDlg::OnSelChangeWeight()
{
	GetResults();
}

//------------------------------------------------
void CGetTotalPwrDlg::OnTimer(UINT_PTR nIDEvent)
{
	CDialog::OnTimer(nIDEvent);

	GetResults();
}


//------------------------------------------------
void CGetTotalPwrDlg::GetResults()
{
	if ( m_SP == NULL) return;

	CString szStart;
	m_EDStartHz.GetWindowText(szStart);
	float startHz = (float)atof(szStart);

	CString szStop;
	m_EDStopHz.GetWindowText(szStop);
	float stopHz = (float)atof(szStop);

	int weight = m_CBWeight.GetItemData(m_CBWeight.GetCurSel());

	try
	{
		CString szPwr;

		float pwr_L = 0.0;
		m_SP->GetTotalPowerSpan(0, weight, startHz, stopHz, &pwr_L);
		szPwr.Format("%0.4f", pwr_L);
		m_EDPwr_L.SetWindowText(szPwr);

		float pwr_R = 0.0;
		m_SP->GetTotalPowerSpan(1, 0, startHz, stopHz, &pwr_R);
		szPwr.Format("%0.4f", pwr_R);
		m_EDPwr_R.SetWindowText(szPwr);

		float diff_LR = pwr_L - pwr_R;
		szPwr.Format("%0.4f", diff_LR);
		m_EDPwr_LR.SetWindowText(szPwr);

		float diff_RL = pwr_R - pwr_L;
		szPwr.Format("%0.4f", diff_RL);
		m_EDPwr_RL.SetWindowText(szPwr);
	}
	catch ( _com_error &error )
	{
		KillTimer( ID_MY_TIMER );
		MessageBox( error.ErrorMessage() );
	}
	
}
